// use std::collections::HashMap;
// use std::convert::Infallible;
// use std::str::from_utf8;
// use std::sync::Arc;
// use tokio::sync::RwLock;
// use casbin::prelude::*;

use warp::{
    filters::header::headers_cloned,
    filters::method::method,
    filters::BoxedFilter,
//    filters::path::{full, FullPath},
//    http::{header::AUTHORIZATION, method::Method, HeaderMap, HeaderValue},
    Filter,// Rejection,
};

use app_env::AppStore;

use app_auth::{
  AppAuthDBs,
  AuthStore,
  Sessions,
  // AuthError, 
  // UserCtx, 
  // WebResult,
  // BEARER_PREFIX,
  // custom_reject
};

use app_file_handlers::{upload_handler,uploadin_handler};

#[must_use] 
pub fn files(
  app_db: AppStore,
  auth_db: AuthStore,
//) -> impl Filter<Extract = impl warp::Reply, Error = warp::Rejection> + Clone {
) -> BoxedFilter<(impl warp::Reply,)> {
    let app_auth_dbs = AppAuthDBs { app: app_db, auth: auth_db};
    upload(app_auth_dbs.clone())
    // .or(ui(app_auth_dbs.clone()))
    .or(uploadin(app_auth_dbs.clone()))
    .boxed()
}
/*
struct FutureReply<F>(F);
impl<F: futures::Future<Output = impl Reply> + std::marker::Send> Reply for FutureReply<F> {
    fn into_response(self) -> warp::reply::Response {
        futures::executor::block_on(self.0).into_response()
    }
}

// https://www.reddit.com/r/rust/comments/hv06wy/how_to_get_boxedfilter_for_warp_multipart_fiilter/
#[must_use]
pub fn uploadin(
  db: AppAuthDBs
//) -> impl Filter<Extract = impl warp::Reply, Error = warp::Rejection> + Clone {
//) -> BoxedFilter<(impl warp::Reply,)> {
) -> BoxedFilter<(FutureReply<impl futures::Future<Output = impl Reply>>,)> {
      warp::path!("uploadin")
        // .and(warp::post())
        .and(warp::multipart::form())
        .and(warp::body::json())
        .and(headers_cloned())
        .and(method())
        .and(with_dbauth(db))
        .map(uploadin_handler)
        .map(|fut| FutureReply(fut))
        .boxed()
}
*/
// #[must_use]
// pub fn ui(
//   db: AppAuthDBs
// //) -> impl Filter<Extract = impl warp::Reply, Error = warp::Rejection> + Clone {
// ) -> BoxedFilter<(impl warp::Reply,)> {
//       warp::path!("ui")
//         .and(headers_cloned())
//         .and(method())
//         .and(with_dbauth(db))
//         .and_then(ui_handler)
//         .boxed()
// }

#[must_use]
pub fn uploadin(
  db: AppAuthDBs
//) -> impl Filter<Extract = impl warp::Reply, Error = warp::Rejection> + Clone {
) -> BoxedFilter<(impl warp::Reply,)> {
      warp::path!("uploadin")
        .and(warp::post())
        .and(warp::multipart::form().max_length(5_000_000))
        .and(headers_cloned())
        .and(method())
        .and(with_dbauth(db))
        /*
        .and_then(|form: warp::multipart::FormData| {
          async {
            // Collect the fields into (name, value): (String, Vec<u8>)
            let part: Result<Vec<(String, Vec<u8>)>, warp::Rejection> = form
                .and_then(|part| {
                    let name = part.name().to_string();
                    let value = part.stream().try_fold(Vec::new(), |mut vec, data| {
                        vec.put(data);
                        async move { Ok(vec) }
                    });
                    value.map_ok(move |vec| (name, vec))
                })
                .try_collect()
                .await
                .map_err(|e| {
                   panic!("multipart error: {:?}", e);
                });
            part
        }})
        */
        .and_then(uploadin_handler)
        .boxed()
}
#[must_use]
pub fn upload(
  db: AppAuthDBs
//) -> impl Filter<Extract = impl warp::Reply, Error = warp::Rejection> + Clone {
) -> BoxedFilter<(impl warp::Reply,)> {
      warp::path!("upload")
        .and(headers_cloned())
        .and(method())
        .and(with_dbauth(db))
        .and_then(upload_handler)
        .boxed()
}

#[must_use] 
pub fn with_dbauth(db: AppAuthDBs) -> impl Filter<Extract = (AppAuthDBs,), Error = std::convert::Infallible> + Clone {
    warp::any().map(move || db.clone())
}

#[must_use] 
pub fn with_sessions(sessions: Sessions) -> impl Filter<Extract = (Sessions,), Error = std::convert::Infallible> + Clone {
    warp::any().map(move || sessions.clone())
}

